﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FullScreenEvent;
	import flash.ui.Mouse;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.filters.BlurFilter;
	import flash.filters.BitmapFilter;
    import flash.filters.BitmapFilterQuality;

	public class Damier extends Sprite
	{
	
		private var col:Number = 101;
		private var line:Number = 101;
		private var grid:Sprite;
		private var points:Array;
		private var amplitude:Number = 1000;
		private var diametre:Number = 100;
		
		private var shift:Number = 6;
		
		private var o:Object;
		private var b:BitmapData;
		private var toCopy:BitmapData;
		private var loader:Loader;
		private var img:Bitmap;
		
		private var brightness:Number;
		private var pixel:uint;
		
		private var filter:BitmapFilter;
		private var blur:BlurFilter;
		private var rect:Rectangle = new Rectangle(0,0, stage.stageWidth,stage.stageHeight);
		private var pt:Point = new Point(0,0);
		
		private var startBlur:int = 200;
		private var blurX:int = startBlur;
		private var blurY:int = startBlur;
		
		private var maxHeight:int = 20;
		
		private var imgRastretize:Array=new Array("data/timeForCode.jpg", "data/useOldIdeas.jpg", "data/interactions.jpg", "data/beCritical.jpg", "data/advice.jpg");
		private var heightParams:Array=new Array(28,35,20,18,15)
		
		public function Damier()
		{
			grid = new Sprite();
			addChild(grid);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, DownHandler);
						
			loadImage();
		}
		
		private function DownHandler(e:Event):void
		{			
			graphics.clear();
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			loadImage();
			
			blurX = startBlur;
			blurY = startBlur;			

		}
		
		private function loadImage():void {
			
			loader = new Loader();
			var randomer:int = Math.floor(Math.random()*imgRastretize.length);
			maxHeight = heightParams[randomer];
			
			var urlRequest:URLRequest=new URLRequest(imgRastretize[randomer]);
			loader.load(urlRequest);	
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, imageLoaded);
		}
		
		private function imageLoaded(e:Event)
		{
			toCopy = new BitmapData(stage.stageWidth,stage.stageHeight,false)
			toCopy.draw(loader);
			
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		
		private function enterHandler(e:Event):void
		{
			blurX = blurY /= 1.05;
			
			if(blurX <= 20){blurX = blurY = 20}
			
			filter = new BlurFilter(blurX, blurY, BitmapFilterQuality.LOW);
			toCopy.draw(loader);
			toCopy.applyFilter(toCopy, rect, pt, filter);
			
			points = new Array();
			grid.graphics.clear();
			grid.graphics.lineStyle(1,0xffffff);
			
			
			for(var i:int = 0; i < col-1; i++){
				for(var j:int = 0; j < line; j++){
					
					//	calcul de la hauteur de chaque points qui constituent 
					//	les ligne en fonction du pixel se trouvant au-dessous
					pixel = toCopy.getPixel(j*shift, i*shift);
					brightness = pixel / 0xFFFFFF;
					points.push({"x":j*shift,"y":i*shift+(Math.random()*mouseX/200)+(brightness*mouseY/20)-mouseY/20});//maxHeight
					
					//	j'enlève le "cafouillage" à la fin de chaque ligne, 
					//	il y a surement mieux à faire!
					if(j == line-1) points[points.length-1].x = j*shift + 1000;
				}
			}
			
			for(var k:Number=0;k<points.length;k++){
				
				if((k+1)%col != 0){
					grid.graphics.moveTo(points[k].x,points[k].y);
					grid.graphics.lineTo(points[k+1].x,points[k+1].y);
				}
			}
		}
	}
}